<?php

declare(strict_types=1);

namespace cin\vivawallet_5\adminmenu;

use JTL\Plugin\Helper as PluginHelper;
use JTL\Plugin\PluginInterface;
use Plugin\cin_vivawallet_5\paymentmethod\VivaWalletEx;

/**
 * @var JTL\Backend\AdminAccount $oAccount
 * @var PluginInterface          $_plugin
 */

require_once \dirname(__DIR__, 3).'/admin/includes/admininclude.php';
$oAccount->permission('PLUGIN_ADMIN_VIEW', true, true);

require_once \dirname(__DIR__, 1).'/src/warmup.php';

/** Load Lang
 * Shop::Container()->getGetText()->loadPluginLocale('base', $_plugin);*/
$response = '';

$params = array_merge($_GET, $_POST);
if ('application/json' === (getallheaders()['Content-Type'] ?? '')) {
  $params = array_merge($params, json_decode(file_get_contents('php://input'), true) ?? []);
}

/** Load Plugin
 * $pluginID = $_GET['kPlugin'];
 * $cinPlugin = PluginHelper::getLoaderByPluginID($pluginID)->init($pluginID, true); */

require_once PFAD_ROOT.'includes/src/Plugin/Payment/Method.php';

switch ($_SERVER['REQUEST_METHOD'].'_'.$params['action']) {
  case 'POST_code':

    if ('redirect' === $params['data']['method']) {
      require_once $P->getJTlPlugin()->getPaths()->getBasePath().'paymentmethod/VivaWalletEx.php';
      $moduleID = PluginHelper::getModuleIDByPluginID($P->getJTlPlugin()->getID(), 'vivawallet redirect');
      $vw       = new VivaWalletEx($moduleID);
      $response = $vw->_createSourceCode(('demo' === $params['data']['mode']));
    }

    break;
  default:
}

http_response_code((($response['success'] ?? false) ? 200 : ($response['code'] ?? 400)));
exit(json_encode($response, 512));
