<?php

declare(strict_types=1);

use JTL\Plugin\Helper;
use Plugin\cin_vivawallet_5\paymentmethod\VivaWalletEx;
use Plugin\cin_vivawallet_5\paymentmethod\VivaWalletNative;

require_once \dirname(__DIR__, 3).'/admin/includes/admininclude.php';
$oAccount->permission('PLUGIN_ADMIN_VIEW', true, true);

require_once \dirname(__DIR__, 1).'/src/warmup.php';

$jtlPlugin = $P->getJTlPlugin();
$params    = array_merge($_GET, $_POST);
$response  = [
  'status'  => 'success',
  'message' => '',
  'data'    => ''
];
if (isset($params['action'])) {
  switch ($params['action']) {
    case 'testconnection':

      require_once PFAD_ROOT.'includes/src/Plugin/Payment/Method.php';

      if ('redirect' === $params['method']) {
        require_once $jtlPlugin->getPaths()->getBasePath().'paymentmethod/VivaWalletEx.php';
        $modulID = Helper::getModuleIDByPluginID($jtlPlugin->getID(), 'vivawallet redirect');
        $vw      = new VivaWalletEx($modulID);
      } elseif ('native' === $params['method']) {
        require_once $jtlPlugin->getPaths()->getBasePath().'paymentmethod/VivaWalletNative.php';
        $modulID = Helper::getModuleIDByPluginID($jtlPlugin->getID(), 'viva wallet');
        $vw      = new VivaWalletNative($modulID);
      }

      $result = $vw->_testconnection($params['mode'], $params);

      if ($result) {
        $response['message'] = 'Verbindung erfolgreich';
      } else {
        $response['message'] = 'Verbindung fehlgeschlagen';
        $response['status']  = 'error';
      }
      $response['data'] = $params;

      break;
    default:
      $response['status']  = 'error';
      $response['message'] = "action '{$params['action']}' is not defined";
  }
} else {
  $response['status']  = 'error';
  $response['message'] = 'no action stated';
}
header('Content-Type: application/json');
exit(json_encode($response, 512));
