<?php

declare(strict_types=1);

use JTL\Plugin\Helper;
use JTL\Shop;

/** @var JTL\Backend\AdminAccount $oAccount */

require_once \dirname(__DIR__, 3).'/admin/includes/admininclude.php';
require \dirname(__DIR__, 1).'/src/warmup.php';
$oAccount->permission('PLUGIN_ADMIN_VIEW', true, true);

if (empty($_GET['kPlugin'])) {
  exit('missing kPlugin get paramter (reg)');
}

$cin_kPlugin = $_GET['kPlugin'];
$jtlPlugin   = $P->getJTlPlugin();
$pdo         = Shop::Container()->getDB()->getPDO();
// $jtlPlugin   = Helper::getLoaderByPluginID($cin_kPlugin)->init($cin_kPlugin, true);

// require_once __DIR__ . '/../includes/bootstrap_plugin.php';

$smarty->assign('assetpath', $jtlPlugin->getPaths()->getAdminURL());
$smarty->assign('commonpath', $jtlPlugin->getPaths()->getBaseURL().'common/');
$smarty->assign('kPlugin', $cin_kPlugin);

if ('GET' === $_SERVER['REQUEST_METHOD']) {
  header_remove();
  header('Content-Type: text/html; charset="utf-8"');
  if (file_exists($jtlPlugin->getPaths()->getBasePath().'applicationsent')) {
    exit($smarty->display('tpl/vivawallet_registration_success.tpl'));
  }
  $stmt = $P->getPDO()->prepare('SELECT * FROM tfirma LIMIT 1;');

  $stmt->execute();
  $firma = $stmt->fetchAll(PDO::FETCH_ASSOC);
  $smarty->assign('firma', $firma);
  $smarty->display('tpl/vivawallet_registration.tpl');
}

if ('POST' === $_SERVER['REQUEST_METHOD']) {
  $emailSettings = retrieveEmailSettings();
  $mailer        = new PHPMailer\PHPMailer\PHPMailer();
  configureMailer();
  $mailer->Subject = "Viva Wallet Kontoantrag von {$_REQUEST['Firmenname']}";
  $mailer->addAddress('support@com-ins-netz.de', 'CiN GmbH');

  $html = "Viva Wallet Kontoantrag von {$_REQUEST['Firmenname']}";
  $html .= '<dl>';
  foreach ($_REQUEST as $key => $value) {
    if ('kPlugin' !== $key) {
      $html .= '<dt>'.str_replace('_', ' ', $key).'</dt><dd>'.$value.'</dd>';
    }
  }
  $html .= '</dl>';
  $mailer->Body = $html;

  $plain = "Viva Wallet Kontoantrag von {$_REQUEST['Firmenname']}\n\n";
  foreach ($_REQUEST as $key => $value) {
    if ('kPlugin' !== $key) {
      $plain .= str_replace('_', ' ', $key).": {$value}\n";
    }
  }
  $mailer->AltBody = $plain;

  foreach ($_FILES as $file) {
    $mailer->addAttachment($file['tmp_name'], $file['name']);
  }

  $success = $mailer->send();

  if ($success) {
    touch($jtlPlugin->getPaths()->getBasePath().'applicationsent');
    $response = ''; // $smarty->fetch('vivawallet_registration_success.tpl');
  } else {
    $response = $mailer->ErrorInfo;
  }
  exit($response);
}

function retrieveEmailSettings()
{
  $settings = [];
  $pdo      = Shop::Container()->getDB()->getPDO();
  $stmt     = $pdo->prepare('SELECT * FROM teinstellungen WHERE cName LIKE "email_%";');
  $stmt->execute();
  $rows = $stmt->fetchAll(PDO::FETCH_ASSOC);
  foreach ($rows as $row) {
    $settings[$row['cName']] = $row['cWert'];
  }

  return $settings;
}

function configureMailer(): void
{
  global $emailSettings;
  global $mailer;
  switch ($emailSettings['email_methode']) {
    case 'smtp':
      configureSMTP();

      break;
    case 'sendmail':
      configureSendmail();

      break;
  }
  $mailer->setFrom($_REQUEST['E-Mail']);
  $mailer->From     = $_REQUEST['E-Mail'];
  $mailer->FromName = "{$_REQUEST['Firmenname']} ({$_REQUEST['Vorname']} {$_REQUEST['Nachname']})";
  $mailer->isHTML(true);
  $mailer->CharSet  = 'UTF-8';
  $mailer->Encoding = 'base64';
}

function configureSMTP(): void
{
  global $emailSettings;
  global $mailer;
  $mailer->isSMTP();
  $mailer->Host       = $emailSettings['email_smtp_hostname'];
  $mailer->Port       = $emailSettings['email_smtp_port'];
  $mailer->Username   = $emailSettings['email_smtp_user'];
  $mailer->Password   = $emailSettings['email_smtp_pass'];
  $mailer->SMTPSecure = $emailSettings['email_smtp_verschluesselung'];
  $mailer->SMTPAuth   = '1' === $emailSettings['email_smtp_auth'];
}

function configureSendmail(): void
{
  global $emailSettings;
  global $mailer;
  $mailer->isSendMail();
  $mailer->Sendmail = $emailSettings['email_sendmail_pfad'];
}
