<?php

declare(strict_types=1);

use Plugin\cin_vivawallet_5\paymentmethod\VivaWalletEx;
use Plugin\cin_vivawallet_5\paymentmethod\VivaWalletNative;

require_once \dirname(__DIR__, 3).'/includes/globalinclude.php'; // die(var_dump($_SESSION));
require_once \dirname(__DIR__, 3).'/includes/bestellabschluss_inc.php';
require_once \dirname(__DIR__, 3).'/includes/mailTools.php';
require_once \dirname(__DIR__, 1).'/src/warmup.php';
require_once \dirname(__DIR__, 1).'/paymentmethod/VivaWalletNative.php';

$pluginID = $P->getJTlPlugin()->getID();
$params   = array_merge($_GET, $_POST);
$response = [
  'status'  => 'ok',
  'message' => '',
  'data'    => new stdClass()
];
switch ($params['action']) {
  case 'charge':
    if ('redirect' === $this->cfg['cin_vivawallet_method']) {
      $vivawallet = new VivaWalletEx('kPlugin_'.$params['kPlugin'].'_vivawallet');
    } else {
      $vivawallet = new VivaWalletNative('kPlugin_'.$params['kPlugin'].'_vivawallet');
    }

    $result   = $vivawallet->_charge($params['token']/*, $params['mobilephonenumber']*/);
    $response = array_merge($response, $result);
    if ('success' === $result['status']) {
      $bestellung = getOrderHandler()->finalizeOrder(null, true);
      if (isset($bestellung->kBestellung) && $bestellung->kBestellung > 0) {
        $vivawallet->addIncomingPayment($bestellung, $result['data'])->_cleanSession();
        $response['data']->return = $bestellung->BestellstatusURL;
      }
    } else {
      $response['status'] = 'error';
    }

    break;
  default:
    $response['status']  = 'error';
    $response['message'] = "action '{$params['action']}' is not defined";
}

ob_clean();
header('Content-Type: application/json');
exit(json_encode($response, 512));
