<?php

declare(strict_types=1);
require \dirname(__DIR__, 2).'/src/warmup.php';

if ( ! $L->canRun()) {
  return;
}

if ( ! $P->getConfig('anti_plugin_cache')) {
  return;
}

$disabled = unserialize(
  $P->getPDO()
    ->query('SELECT cWert FROM teinstellungen where cName = "caching_types_disabled"')
    ->fetchColumn()
);
if (false === $disabled) {
  $disabled = [];
} else {
  $disabled = array_filter($disabled, static function ($val) {
    return 'plgn' !== $val;
  });
}
$disabled[] = 'plgn';
$disabled   = serialize($disabled);

$stmt = $P->getPDO()->prepare('UPDATE teinstellungen SET cWert = :disabled WHERE cName = "caching_types_disabled"');
$stmt->execute([':disabled' => $disabled]);
