<?php

declare(strict_types=1);
use JTL\Shop;

// require_once dirname(__DIR__, 2) . '/includes/bootstrap_plugin.php';
require \dirname(__DIR__, 2).'/src/warmup.php';

const SELECTOR_ADRESSE  = '.nav.stepper > div:nth-child(1)';
const SELECTOR_VERSAND  = '.nav.stepper > div:nth-child(2)';
const SELECTOR_ZUSAMMEN = '.nav.stepper > div:nth-child(3)';
const SELECTOR_ZAHLUNG  = '.nav.stepper > div:nth-child(4)';

/** @var JTLSmarty $smarty */
$pdo  = $P->getPDO();
$stmt = $pdo->prepare('SELECT
  CONCAT("cin_vivawallet_5", cName) as cName,
  cWert
  FROM tsprachwerte
  WHERE kSprachISO=:kSprachISO
  AND cName IN ("billingAndDeliveryAddress", "shippingAndPaymentOptions", "summary");');
$stmt->execute([
  ':kSprachISO' => $_SESSION['kSprachISO']
]);

$navbarLang = array_map(
  static function ($el) {
    return $el['cWert'];
  },
  $stmt->fetchAll(PDO::FETCH_ASSOC)
);

$lang = array_merge($navbarLang, $lang);
$stmt = $pdo->prepare("SELECT kZahlungsart FROM tzahlungsart WHERE cName='Viva wallet'");
$stmt->execute();
$native_ID = $stmt->fetchColumn();

$stmt = $pdo->prepare("SELECT kZahlungsart FROM tzahlungsart where cName ='Viva.com';");
$stmt->execute();
$redirect_ID = $stmt->fetchColumn();

if (isset($_SESSION['AktiveZahlungsart'])) {
  if ((int) $_SESSION['AktiveZahlungsart'] === $native_ID) {
    $step = '';
    switch (Shop::getPageType()) {
      case PAGE_BESTELLVORGANG:

        pq('#complete-order-button')->text($lang['cin_vivawallet_continuetopayment']);
        $smarty->assign('lang', $lang);
        $template = $smarty->fetch(__DIR__.'/../template/inc_steps.tpl');
        pq('#result-wrapper .container .nav.stepper')->html($template);

        if (isset($_GET['editRechnungsadresse'])) {
          $step = 'adresse';
          /* ACTIVE */ pq(SELECTOR_ADRESSE)->addClass('step-current')->removeClass('col-auto');
          /* TEXT */ pq(SELECTOR_ADRESSE.' .step-text')->removeClass('d-none d-md-inline-block');
        }
        if (isset($_GET['editVersandart']) || isset($smarty->getTemplateVars()['step']) && 'Zahlung' === $smarty->getTemplateVars()['step']) {
          $step = 'versand';
          /* ACTIVE */ pq(SELECTOR_VERSAND)->addClass('step-current')->removeClass('col-auto');
          /* TEXT */ pq(SELECTOR_VERSAND.' .step-text')->removeClass('d-none d-md-inline-block');
        }
        if (isset($smarty->getTemplateVars()['step']) && 'Bestaetigung' === $smarty->getTemplateVars()['step']) {
          $step = 'zusammenfassung';
          /* ACTIVE */ pq(SELECTOR_ZUSAMMEN)->addClass('step-current')->removeClass('col-auto');
          /* TEXT */ pq(SELECTOR_ZUSAMMEN.' .step-text')->removeClass('d-none d-md-inline-block');
        }

        break;

      case PAGE_BESTELLABSCHLUSS:
        $step = 'zahlung';
        /* ACTIVE */ pq(SELECTOR_ZAHLUNG)->addClass('step-current')->removeClass('col-auto');
        /* TEXT */ pq(SELECTOR_ZAHLUNG.' .step-text')->removeClass('d-none d-md-inline-block');
        pq('.breadcrumb-wrapper')->remove();
        pq('#content #content>h1')->remove();
        $smarty->assign('lang', $lang);
        $navOpener = '<nav class="nav stepper checkout-steps" aria-label="Sichere Bezahlung">';
        pq('#content #content')->prepend($navOpener.$smarty->fetch(__DIR__.'/../template/inc_steps.tpl').'</ul>');

        break;
    }

    switch ($step) {
      case 'zahlung':
        /* CHECK */ pq(SELECTOR_ZUSAMMEN.'.col-auto .step-content')->append('<span class="fas fa-check step-check"></span>');
        /* BADGE */ pq(SELECTOR_ZAHLUNG.' .badge')->addClass('badge-primary')->removeClass('badge-secondary');
        /* DONE */ pq(SELECTOR_ZAHLUNG)->addClass('step-active');

        // no break
      case 'zusammenfassung':
        /* CHECK */ pq(SELECTOR_VERSAND.'.col-auto .step-content')->append('<span class="fas fa-check step-check"></span>');
        /* BADGE */ pq(SELECTOR_ZUSAMMEN.' .badge')->addClass('badge-primary')->removeClass('badge-secondary');
        /* DONE */ pq(SELECTOR_ZUSAMMEN)->addClass('step-active');

        // no break
      case 'versand':
        /* CHECK */ pq(SELECTOR_ADRESSE.'.col-auto .step-content')->append('<span class="fas fa-check step-check"></span>');
        /* BADGE */ pq(SELECTOR_VERSAND.' .badge')->addClass('badge-primary')->removeClass('badge-secondary');
        /* DONE */ pq(SELECTOR_VERSAND)->addClass('step-active');

        // no break
      case 'adresse':
        /* BADGE */ pq(SELECTOR_ADRESSE.' .badge')->addClass('badge-primary')->removeClass('badge-secondary');
        /* DONE */ pq(SELECTOR_ADRESSE)->addClass('step-active');
    }
  } elseif ($_SESSION['AktiveZahlungsart'] === $redirect_ID) {
    if (PAGE_BESTELLVORGANG === Shop::getPageType() && isset($smarty->getTemplateVars()['step']) && 'Bestaetigung' === $smarty->getTemplateVars()['step'] && isset($_GET['vw_msg'])) {
      $smarty->assign('vw_msg', $_GET['vw_msg']);
      pq('#order-confirm')->prepend($smarty->fetch(__DIR__.'/../template/vw_alert.tpl'));
    }
  }
}

if (PAGE_BESTELLSTATUS === Shop::getPageType()) {
  // die(var_dump(Shop::getPageType(), $_SESSION['AktiveZahlungsart']));
  // ? ? ?
  if ( ! isset($_SESSION['Kunde']) || empty($_SESSION['Kunde']->kKunde)) {
    pq('#account>div:first-child')->remove();
    pq('#account>div:first-child')->removeClass('col-md-9');
  }
}
