<?php

declare(strict_types=1);

use JTL\Plugin\Helper;
use Plugin\cin_vivawallet_5\paymentmethod\VivaWallet;
use Plugin\cin_vivawallet_5\paymentmethod\VivaWalletEx;
use Plugin\cin_vivawallet_5\paymentmethod\VivaWalletNative;

require_once \dirname(__DIR__, 3).'/includes/globalinclude.php';

require_once \dirname(__DIR__, 1).'/src/warmup.php';
// require_once \dirname(__DIR__, 1).'/paymentmethod/VivaWallet.php';

if ('redirect' === $this->cfg['cin_vivawallet_method']) {
  $vivawallet = new VivaWalletEx(Helper::getModuleIDByPluginID($P->getJTlPlugin()->getID(), 'viva wallet'));
} else {
  $vivawallet = new VivaWalletNative(Helper::getModuleIDByPluginID($P->getJTlPlugin()->getID(), 'viva wallet'));
}
// $vivawallet = new VivaWallet(Helper::getModuleIDByPluginID($P->getJTlPlugin()->getID(), 'viva wallet'));

$paymentDetails = $vivawallet->GetPaymentDetails();
// TODO check converting
$paymentDetails['lang'] = array_map(static function ($string) {
  return mb_convert_encoding($string, 'UTF-8', mb_detect_encoding($string, 'UTF-8, WINDOWS-1252, ISO-8859-1', true));
}, $paymentDetails['lang']);
header_remove();
header('Content-Type: application/json');
echo json_encode($paymentDetails, 512);
